---
title: XRPermissionDescriptor
slug: Web/API/XRPermissionDescriptor
tags:
  - API
  - AR
  - Dictionary
  - Mixed
  - Permissions
  - Reality
  - Reference
  - VR
  - Virtual
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRPermissionDescriptor
  - augmented
  - descriptor
---
<p>{{APIRef("WebXR Device API")}}{{SecureContext_header}}</p>

<p><span class="seoSummary">User permissions in the <a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API</a> are managed using the <a href="/en-US/docs/Web/API/Permissions_API">Permissions API</a>. To that end, the <code><strong>XRPermissionDescriptor</strong></code> dictionary is used to describe the WebXR features the app needs to use, as well as those features it would like ot use if permision is granted.</span></p>

<p>The <code>XRPermissionDescriptor</code>'s {{domxref("PermissionDescriptor.name", "name")}} must be set to <code>xr</code> in order to direct the Permissions API to correctly handle the request as applying to WebXR.</p>

<h2 id="Properties">Properties</h2>

<p>In addition to inheriting the properties of the parent interface, {{domxref("PermissionDescriptor")}}, <code>XRPermissionDescriptor</code> provides the following properties.</p>

<dl>
	<dt>{{domxref("XRPermissionDescriptor.mode", "mode")}} </dt>
	<dd>An {{domxref("XRSessionMode")}} value indicating the XR mode (<code>inline</code>, <code>immersive-vr</code>, or <code>immersive-ar</code>) for which the permissions are requested.</dd>
	<dt>{{domxref("XRPermissionDescriptor.optionalFeatures", "optionalFeatures")}}</dt>
	<dd>An array of strings, each specifying the name of a WebXR feature which is requested but not required for the app to function. The available features are the same as those used by {{domxref("XRSessionInit")}}; see {{SectionOnPage("/en-US/docs/Web/API/XRSessionInit", "Default features")}} for further information.</dd>
	<dt>{{domxref("XRPermissionDescriptor.requiredFeatures", "requiredFeatures")}}</dt>
	<dd>An array of strings giving the names of the <a href="/en-US/docs/Web/API/XRSessionInit#Default_features">WebXR features</a> for which permission <em>must</em> be obtained in order to use your app or site.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>The example below demonstrates performing the permission request for an application that requires the <code>local-floor</code> reference space in an <code>immersive-vr</code> environment.</p>

<p>If the <a href="/en-US/docs/Web/API/Permissions_API">Permissions API</a> is found to be available (by checking to see if {{domxref("navigator.permissions")}} is defined), its {{domxref("Permissions.query", "query()")}} method is called, specifying the permission descriptor we've established, <code>xrPermissionDesc</code>.</p>

<p>When the returned <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise">promise</a> resolves, we check the returned status. If permission has been granted, we call a function <code>setupXR()</code> that handles preparing the WebXR environment for use. If permission is conditional based on prompting, we call a function <code>promptAndSetupXR()</code> that would handle asking for permission before enabling and starting up the environment. And for any other returned state—which is almost certainly <code>denied</code>, which is the only other option as of this article's writing—we do nothing, since we can't use WebXR.</p>

<p>If the permission request promise is rejected, the error is handled (currently by just dumping it to the console using domxref("console.log()")}}).</p>

<p>If the Permissions API isn't available at all, this example assumes that WebXR will report an appropriate error if permission isn't available, and tries to start up the WebXR session using the same <code>setupXR()</code> function called by the <code>granted</code> case.</p>

<pre class="brush: js">let xrPermissionDesc = {
  name: "xr",
  mode: "immersive-vr",
  requiredFeatures: [ "local-floor" ]
};

if (navigator.permissions) {
  navigator.permissions.query(xrPermissionDesc).then(({state}) =&gt; {
    switch(state) {
      case "granted":
        setupXR();
        break;
      case "prompt":
        promptAndSetupXR();
        break;
      default:
        /* do nothing otherwise */
       break;
  }
  .catch(err) {
    console.log(err);
  }
} else {
  setupXR();
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{SpecName('WebXR','#dictdef-xrpermissiondescriptor','XRPermissionDescriptor')}}</td>
			<td>{{Spec2('WebXR')}}</td>
			<td>Initial definition.</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XRPermissionDescriptor")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li><a href="/en-US/docs/Web/API/WebXR_Device_API/Permissions_and_security">Permissions and security for WebXR</a></li>
	<li>{{domxref("XRPermissionStatus")}}</li>
	<li>{{domxref("navigator.permissions")}} and {{domxref("WorkerNavigator.permissions")}}</li>
	<li>{{domxref("Permissions")}}</li>
</ul>
